/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.pl.equipment.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.secure.BladeUser;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.pl.equipment.entity.EquipmentEntity;
import org.springblade.modules.pl.equipment.vo.EquipmentVO;
import org.springblade.modules.pl.equipment.excel.EquipmentExcel;
import org.springblade.modules.pl.equipment.wrapper.EquipmentWrapper;
import org.springblade.modules.pl.equipment.service.IEquipmentService;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.tool.utils.DateUtil;
import org.springblade.core.excel.util.ExcelUtil;
import org.springblade.core.tool.constant.BladeConstant;
import springfox.documentation.annotations.ApiIgnore;
import java.util.Map;
import java.util.List;
import javax.servlet.http.HttpServletResponse;

/**
 * 设备表 控制器
 *
 * @author BladeX
 * @since 2023-12-05
 */
@RestController
@AllArgsConstructor
@RequestMapping("pl-equipment/equipment")
@Api(value = "设备表", tags = "设备表接口")
public class EquipmentController extends BladeController {

	private final IEquipmentService equipmentService;

	/**
	 * 设备表 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入equipment")
	public R<EquipmentVO> detail(EquipmentEntity equipment) {
		EquipmentEntity detail = equipmentService.getOne(Condition.getQueryWrapper(equipment));
		return R.data(EquipmentWrapper.build().entityVO(detail));
	}
	/**
	 * 设备表 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入equipment")
	public R<IPage<EquipmentVO>> list(@ApiIgnore @RequestParam Map<String, Object> equipment, Query query) {
		query.setDescs("create_time");
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			equipment.put("factory_id",user.getFactoryId());
		}
		IPage<EquipmentEntity> pages = equipmentService.page(Condition.getPage(query), Condition.getQueryWrapper(equipment, EquipmentEntity.class));
		return R.data(EquipmentWrapper.build().pageVO(pages));
	}

	/**
	 * 设备表 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入equipment")
	public R<IPage<EquipmentVO>> page(EquipmentVO equipment, Query query) {
		IPage<EquipmentVO> pages = equipmentService.selectEquipmentPage(Condition.getPage(query), equipment);
		return R.data(pages);
	}

	/**
	 * 设备表 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入equipment")
	public R save(@Valid @RequestBody EquipmentEntity equipment) {
		return R.status(equipmentService.save(equipment));
	}

	/**
	 * 设备表 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入equipment")
	public R update(@Valid @RequestBody EquipmentEntity equipment) {
		return R.status(equipmentService.updateById(equipment));
	}

	/**
	 * 设备表 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入equipment")
	public R submit(@Valid @RequestBody EquipmentEntity equipment) {
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			equipment.setFactoryId(user.getFactoryId());
		}
		long count = equipmentService.count(Wrappers.<EquipmentEntity>lambdaQuery().eq(EquipmentEntity::getEqSn,equipment.getEqSn()).ne(equipment.getId()!=null,EquipmentEntity::getId,equipment.getId()));
		if(count>0){
			return R.fail("设备序列号已存在");
		}
		count = equipmentService.count(Wrappers.<EquipmentEntity>lambdaQuery().eq(EquipmentEntity::getMacAddress,equipment.getMacAddress()).ne(equipment.getId()!=null,EquipmentEntity::getId,equipment.getId()));
		if(count>0){
			return R.fail("相机mac地址已存在");
		}
		return R.status(equipmentService.saveOrUpdate(equipment));
	}

	/**
	 * 设备表 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(equipmentService.deleteLogic(Func.toLongList(ids)));
	}


	/**
	 * 导出数据
	 */
	@GetMapping("/export-equipment")
	@ApiOperationSupport(order = 9)
	@ApiOperation(value = "导出数据", notes = "传入equipment")
	public void exportEquipment(@ApiIgnore @RequestParam Map<String, Object> equipment, BladeUser bladeUser, HttpServletResponse response) {
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			equipment.put("factory_id",user.getFactoryId());
		}
		QueryWrapper<EquipmentEntity> queryWrapper = Condition.getQueryWrapper(equipment, EquipmentEntity.class);
		//if (!AuthUtil.isAdministrator()) {
		//	queryWrapper.lambda().eq(Equipment::getTenantId, bladeUser.getTenantId());
		//}
		queryWrapper.lambda().eq(EquipmentEntity::getIsDeleted, BladeConstant.DB_NOT_DELETED);
		List<EquipmentExcel> list = equipmentService.exportEquipment(queryWrapper);
		ExcelUtil.export(response, "设备表数据" + DateUtil.time(), "设备表数据表", list, EquipmentExcel.class);
	}

}
